

#include "FiveWin.ch"
#include "APIRSU.ch"
#include "report.ch"
#include "StdRSU.ch"
#include "Common.ch"
#include "InKey.ch"
#include "xbrowse.ch"
#include "Scintilla.ch"
#include "FileIO.ch"

#include "SR_System.ch"

#ifndef __XHARBOUR__
   #include "hbcompat.ch"
#endif


CLASS T7za
   DATA cExe        INIT ""
   DATA cFolder     INIT ""

   METHOD New( )    CONSTRUCTOR
   METHOD Zipper( ) INLINE ::cFolder + "\"+ ::cExe

   METHOD Tar( cOut_Archive_name, cOrg_file_names, lTrace   );
                                                 INLINE ::RunCMD( if(ValType(cOrg_file_names)="A", "u", "a"), "-ttar", cOut_Archive_name, cOrg_file_names, lTrace )

   METHOD GZip( cOut_Archive_name, cOrg_file_names, lTrace  );
                                                 INLINE ::RunCMD( "a", "-tgzip", cOut_Archive_name, cOrg_file_names, lTrace )

   METHOD UnGZip( cOrg_Archive_name, cDest_Directory, lTrace );
                                                 INLINE ::RunCMD( "x", "-y"+" "+"-o"+cDest_Directory, cOrg_Archive_name, lTrace )

   METHOD RunCMD( cCommand, cSwitches, cOut_Archive_name, cOrg_file_names, lTrace )

ENDCLASS

//-------------------//
METHOD New(cExe,cFolder) CLASS T7za
   Default cExe := "7za.exe",;
           cFolder := SetPathBin()

   if File(cFolder+"\"+cExe)
      ::cExe := cExe
      ::cFolder := cFolder
   else
      if File(".\7za.Exe")
         ::cExe := "7za.Exe"
         ::cFolder := "."
      endif
   endif
Return Self
//-------------------//
METHOD RunCMD( cCommand, cSwitches, cOut_Archive_name, cFile_Names, lTrace ) CLASS T7za
   Local lOk := .F.,;
         i,n,cFileTmp,cTxtResult:=""

   Default lTrace := .F.

   if lTrace
      msgtrace("7za:", if(File(::Zipper()),"Zipper OK", "No Zipper" ))
   endif


   if !Empty(::Zipper())

      if ValType(cFile_Names) = "A"

         i := 0
	 n := Len(cFile_Names)
	 do while i < n
	 //for i:=1 to len(cFile_Names)

	    i++

            if Empty(cFile_Names[i])
               if lTrace
                  msgtrace("7za:", "El elemento "+cValToChar(i)+" de lista de archivos esta vacio")
               endif
	    else
               if lTrace
                  msgtrace("7za:", ::Zipper() +" "+ cCommand +" "+  cSwitches +" "+ cOut_Archive_name +" "+ cFile_Names[i])
               endif

               cFileTmp := RunCMD(::Zipper() +" "+ cCommand +" "+  cSwitches +" "+ cOut_Archive_name +" "+ cFile_Names[i], .T. /*lReturnFileResult*/, lTrace)

               cTxtResult :=  Memoread(cFileTmp)

	       if ! ("EVERYTHING IS OK" $ Upper(cTxtResult))
	          exit
	       endif
	    endif

	 //next
	 enddo

      else


         if Empty(cFile_Names)
            if lTrace
               msgtrace("7za:", "El nombre de archivo esta vacio")
            endif
	 else
            if lTrace
               msgtrace("7za:", ::Zipper() +" "+ cCommand +" "+  cSwitches +" "+ cOut_Archive_name +" "+ cFile_Names)
            endif

            cFileTmp := RunCMD(::Zipper() +" "+ cCommand +" "+  cSwitches +" "+ cOut_Archive_name +" "+ cFile_Names, .T. /*lReturnFileResult*/, lTrace)

            cTxtResult :=  Memoread(cFileTmp)
         endif

      endif

      if ("EVERYTHING IS OK" $ Upper(cTxtResult))
         lOk := .T.
      else
         if lTrace
            msgtrace("7za:", cTxtResult)
	 endif
      endif

      if !lTrace
         FErase( cFileTmp )
      endif

   endif
Return lOk

//-------------------//
FUNCTION RunCMD(cCmd, lReturnFileResult, lTrace)
   Local hTmp, cTmpFile, cTmpFileResult

   default lReturnFileResult := .F.,;
           lTrace := .F.

   cTmpFile := Tmp("RunCMD_",".BAT")

   //1. Creamos un archivo temporal
   hTmp := FCREATE(cTmpFile,0)
   if FError() = 0

      if lReturnFileResult
         cTmpFileResult := Tmp("RunCMD_",".RST")
      endif

      if lTrace
         msgtrace("RunCMD:",cCmd + if(lReturnFileResult,' > "' + cTmpFileResult + '"', ''))
      endif

      //2. Colocamo el comando en el archivo temporal
      FWRITE(hTmp, cCmd + if(lReturnFileResult,' > "' + cTmpFileResult + '"', '') ) //+12/05/22
      FCLOSE(hTmp)

      //3. Ejecutamos el comando que esta en el archivo temporal
      WaitRun(cTmpFile,0)

      if !lTrace
         FErase( cTmpFile )
      endif
   endif

RETURN cTmpFileResult
