
#include "FiveWin.ch"
#include "APIRSU.ch"
#include "report.ch"
#include "StdRSU.ch"
#include "Common.ch"
#include "InKey.ch"
#include "xbrowse.ch"
#include "Scintilla.ch"
#include "FileIO.ch"

//#ifdef __FW__1606__
#ifndef __FW__1302__
   #include "hbmxml.ch"
#endif

#include "hbxml.ch"

#include "SR_System.ch"

#ifndef __XHARBOUR__
   #include "hbcompat.ch"
#endif

#ifdef __XHARBOUR__
   #translate HB_HHasKey( <hHash>, <xKey> ) => HHasKey( <hHash>, <xKey> )
   #translate HB_HKeyAt( <hHash>, <nPos> )  => HGetKeyAt( <hHash>, <nPos> )
   #translate HB_HKeys( <hHash> )           => HGetKeys( <hHash> )
   #translate HB_HValues( <hHash> )         => HGetValues( <hHash> )
   #translate HB_MemoRead( <cFileName> )    => MemoRead( <cFileName> )
#endif


//------------------------------------------------//
//TXmlSOAP
//------------------------------------------------//
CLASS TXmlSOAP FROM TXmlDocument
   DATA cPrFjSOAP
   DATA oXmlEnvelope, oXmlHeader, oXmlHeaders, oXmlBody, oXmlFault, oXmlMsg

   METHOD New( uXml, nStyle, cPrFjSOAP ) CONSTRUCTOR

   METHOD SetXmlHeaders( oNewNode )      INLINE if(oNewNode <> NIL, ::oXmlHeaders := oNewNode, NIL),  ::oXmlHeaders
   METHOD SetXmlFault( oNewNode )        INLINE if(oNewNode <> NIL, ::oXmlFault := oNewNode, NIL),    ::oXmlFault
   METHOD SetXmlMsg( oNewNode )          INLINE if(oNewNode <> NIL, ::oXmlMsg := oNewNode, NIL),      ::oXmlMsg

   METHOD BuildXml( )
ENDCLASS
   //------------------------------------------------//
   METHOD New( cXmlString, nStyle, cPrFjSOAP ) CLASS TXmlSOAP

      Default cPrFjSOAP := "soap"

      ::cPrFjSOAP := cPrFjSOAP

      ::Super:New( cXmlString /*nFileHandle|cXmlString*/, nStyle )
   RETURN Self
   //------------------------------------------------//
   METHOD BuildXml( hEnvelopeAttributes /*, hHeader, hBody, hFault, hMsg*/ ) CLASS TXmlSOAP

      Default hEnvelopeAttributes := { "xmlns:env" => "http://www.w3.org/2003/05/soap-envelope" }

      //CREATE ENVELOPE
      ::oXmlEnvelope := TXmlNode():new( HBXML_TYPE_TAG            /*nType*/,;
                                        ::cPrFjSOAP + ":Envelope" /*cTagName*/,;
                                        hEnvelopeAttributes       /*hAttributes*/ )
         //ADD HEADER to Envelope
         if ::oXmlHeaders <> NIL

            // Create Header
            if ::oXmlHeaders <> NIL
               ::oXmlHeader := TXmlNode():new( HBXML_TYPE_TAG          /*nType*/,;
                                               ::cPrFjSOAP + ":Header" /*cTagName*/,;
                                                                       /*hAttributes*/,;
                                                                       /*cData*/)
               ::oXmlHeader:addBelow( ::oXmlHeaders )
            endif

            ::oXmlEnvelope:addBelow( ::oXmlHeader )
         endif

         //ADD BODY to Envelope
         // Create Body
         ::oXmlBody := TXmlNode():new( HBXML_TYPE_TAG        /*nType*/,;
                                       ::cPrFjSOAP + ":Body" /*cTagName*/,;
                                                             /*hAttributes*/,;
                                                             /*cData*/)
            // Add Msg to Body
            if ::oXmlMsg <> NIL
               ::oXmlBody:addBelow( ::oXmlMsg )
            endif

            // Add Fault to Body
            if ::oXmlFault <> NIL
               ::oXmlBody:addBelow( ::oXmlFault )
            endif

         ::oXmlEnvelope:addBelow( ::oXmlBody )

      //ADD ENVELOPE to TXmlDocument:oRoot
      ::oRoot:addBelow( ::oXmlEnvelope )
   RETURN NIL




