
#include "FiveWin.ch"
#include "APIRSU.ch"
#include "report.ch"
#include "StdRSU.ch"
#include "Common.ch"
#include "InKey.ch"
#include "xbrowse.ch"
#include "Scintilla.ch"
#include "FileIO.ch"

//#ifdef __FW__1606__
#ifndef __FW__1302__
   #include "hbmxml.ch"
#endif

#include "hbxml.ch"

#include "SR_System.ch"

#ifndef __XHARBOUR__
   #include "hbcompat.ch"
#endif

/* Error codes */
#define MSXML_ERROR_NONE                            000
#define MSXML_ERROR_FAIL_ON_CREATE                  100
#define MSXML_ERROR_FAIL_ON_CREATE_XSD_SCHEMA       101
#define MSXML_ERROR_FAIL_ON_CREATE_XSD_SCHEMA_CACHE 102
#define MSXML_ERROR_FAIL_ON_CREATE_XML_DOCUMENT     103
#define MSXML_ERROR_HTTP_SEND                       200
#define MSXML_ERROR_HTTP_SEND_SIN_CONEXION          201 //se deshabilito la conexion
#define MSXML_ERROR_HTTP_SEND_NO_RESPONSE           205 //timeout
//#define MSXML_ERROR_HTTP_NO_ACTIVE                  209
#define MSXML_ERROR_RESULT                          300
#define MSXML_ERROR_RESULT_INFORMATIVA              301 //::oHttp:Status 100199 ver https://www.ionos.es/digitalguide/hosting/cuestiones-tecnicas/el-error-http-400-encuentra-sus-causas/
#define MSXML_ERROR_RESULT_SATISFACTORIAS           302 //::oHttp:Status 200299 "
#define MSXML_ERROR_RESULT_REDIRECCIONES            303 //::oHttp:Status 300399 "
#define MSXML_ERROR_RESULT_ERROR_CLIENTE            304 //::oHttp:Status 400499 "
#define MSXML_ERROR_RESULT_ERROR_SERVIDOR           305 //::oHttp:Status 500599 "
#define MSXML_ERROR_VALIDATE                        400
#define MSXML_ERROR_VALIDATE_XSD                    410
#define MSXML_ERROR_VALIDATE_XSD_FILE_XML           411
#define MSXML_ERROR_VALIDATE_XSD_FILE_XSD           412

#ifdef __XHARBOUR__
   #translate HB_HHasKey( <hHash>, <xKey> ) => HHasKey( <hHash>, <xKey> )
   #translate HB_HKeyAt( <hHash>, <nPos> )  => HGetKeyAt( <hHash>, <nPos> )
   #translate HB_HKeys( <hHash> )           => HGetKeys( <hHash> )
   #translate HB_HValues( <hHash> )         => HGetValues( <hHash> )
   #translate HB_MemoRead( <cFileName> )    => MemoRead( <cFileName> )
#endif


//------------------------------------------------//
//TMsXml
//------------------------------------------------//
CLASS TMsXml

   DATA nError               INIT MSXML_ERROR_NONE
   DATA cError               INIT ""
   DATA cContentType
   DATA cUserAgent

   DATA oHttp
   DATA lServerXMLHTTP       INIT .F.

   DATA oXmlDoc,oSchema,oSchemaCache,oParseError

   METHOD New( )             CONSTRUCTOR
   METHOD Reset( )           INLINE  ::ResetHttp( ),;
                                     ::ResetXsd( )

   METHOD SetHttp( )
   METHOD SendHttpRequest( )
   METHOD ResetHttp( )       INLINE  ::oHttp := NIL

   METHOD SetXSD_Schema( )
   METHOD SetXSD_SchemaCache( )
   METHOD SetXSD( cFileXSD ) INLINE  if( ::SetXSD_Schema( cFileXSD ),;
                                         ::SetXSD_SchemaCache( ),;
					 .F.)
   METHOD SetDoc( )
   METHOD ValidateXSD( )
   METHOD ResetXsd( )        INLINE  ::oXmlDoc := NIL,;
                                     ::oSchema := NIL,;
                                     ::oSchemaCache := NIL,;
                                     ::oParseError
ENDCLASS
   //------------------------------------------------//
   METHOD New( cUserAgent, cContentType ) CLASS TMsXml
      Default cContentType := "text/xml; charset=utf-8",;
              cUserAgent   := "Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.0)"

      ::cContentType := cContentType
      ::cUserAgent   := cUserAgent
   RETURN Self
   //------------------------------------------------//
   METHOD SetHttp( ) CLASS TMsXml

      if ::oHttp = NIL

         TRY
            ::oHttp := CreateObject( 'MSXML2.ServerXMLHTTP' )

           /*
            xmlServerHttp.setTimeouts(lResolve, lConnect, lSend, lReceive);
	    valores por defecto (Infinite, 60 seconds, 30 seconds, 30 seconds)
	    https://learn.microsoft.com/en-us/previous-versions/windows/desktop/ms760403(v=vs.85)

	    resolveTimeout
            A long integer. The value is applied to mapping host names (such as "www.microsoft.com") to IP addresses;
	    the default value is infinite, meaning no timeout.

            connectTimeout
            A long integer. The value is applied to establishing a communication socket with the target server, with a default timeout value of 60 seconds.

            sendTimeout
            A long integer. The value applies to sending an individual packet of request data (if any) on the communication socket to the target server.
	    A large request sent to a server will normally be broken up into multiple packets;
	    the send timeout applies to sending each packet individually. The default value is 30 seconds.

            receiveTimeout
            A long integer. The value applies to receiving a packet of response data from the target server.
	    Large responses will be broken up into multiple packets;
	    the receive timeout applies to fetching each packet of data off the socket. The default value is 30 seconds.

	    Ejm.1
            var lResolve = 5 * 1000;   5 segundos
            var lConnect = 5 * 1000;   5 segundos
            var lSend = 15 * 1000;    15 segundos
            var lReceive = 15 * 1000; 15 segundos

	    Ejm2
	    600000, 600000, 15000, 15000
            600 * 1000 = 600000; 600 segundos
           */
	  //::oHttp:setTimeouts(         0,  60 * 1000,  30 * 1000,  30 * 1000) //Default
          //::oHttp:setTimeouts(  5 * 1000,   5 * 1000,  15 * 1000,  15 * 1000) //V1
	    ::oHttp:setTimeouts(  5 * 1000,   5 * 1000,  30 * 1000,  30 * 1000) //V1.1 ok
	  //::oHttp:setTimeouts(600 * 1000, 600 * 1000, 300 * 1000, 300 * 1000) //V2
	  //::oHttp:setTimeouts(100 * 1000, 100 * 1000, 100 * 1000, 100 * 1000) //V3

	    ::lServerXMLHTTP := .T.

         CATCH

            TRY
               ::oHttp := CreateObject( 'MSXML2.XMLHTTP' )
            CATCH

               TRY
                  ::oHttp := CreateObject( 'Microsoft.XMLHTTP' )
               CATCH

                  ::nError := MSXML_ERROR_FAIL_ON_CREATE
                  ::cError := "TMsXml:SetHttp: No se pudo crear 'MSXML2.XMLHTTP'"

               END

            END
         END

      endif

   RETURN ::oHttp <> NIL
   //------------------------------------------------//
   METHOD SendHttpRequest( cMethod, cRequestXML, cUrl, cUserAgent, cContentType, bSetRequestHeader, cHttpDataResponse ) CLASS TMsXml
      Local cResponse := ""
      Local nLenRequestXML

      ::nError := MSXML_ERROR_NONE
      ::cError := ""

      if ::SetHttp( )

         Default cMethod := "POST",;
                 cHttpDataResponse := "responseText" //responseXML | ResponseBody

	 nLenRequestXML := Len( cRequestXML )
         if ::lServerXMLHTTP
	    ::oHttp:setTimeouts(  5 * 1000,   5 * 1000,  30 * 1000 + nLenRequestXML,  30 * 1000)
	 endif

         ::oHttp:Open( cMethod /*method*/, cUrl /*url*/, .F. /*async*/, /*uname*/, /*pswd*/ )

       //::oHttp:SetRequestHeader( "Host",           "servicios.bcn.gob.ni") ) //si fuera necesario se lo establece por medio de 'bSetRequestHeader'
         ::oHttp:SetRequestHeader( "Connection",     "Keep-Alive" ) //dio error con 'MSXML2.ServerXMLHTTP'
         ::oHttp:setRequestHeader( "User-Agent",     IfNil(cUserAgent, ::cUserAgent) )
         ::oHttp:SetRequestHeader( "Content-Type",   IfNil(cContentType, ::cContentType) )
         ::oHttp:SetRequestHeader( "Content-Length", cValToChar( nLenRequestXML ) )
       //::oHttp:SetRequestHeader( "SOAPAction",     "http://servicios.bcn.gob.ni/RecuperaTC_Mes" ) //si fuera necesario se lo establece por medio de 'bSetRequestHeader'

         if bSetRequestHeader <> NIL
            if ValType(bSetRequestHeader) = "H"
               HEval( bSetRequestHeader, {|cKey, uValue| ::oHttp:SetRequestHeader( cKey, uValue ) } )
            else
               Eval(bSetRequestHeader, ::oHttp, Self)
            endif
         endif

         TRY
            ::oHttp:Send( cRequestXML )

            cResponse := oSend(::oHttp, cHttpDataResponse) //con oSend() enviamos a ::oHttp, como mensaje, la DATA a recuperar: cHttpDataResponse -> responseText, responseXML (ResponseBody)

            DO CASE
            CASE ::oHttp:Status >= 100 .AND. ::oHttp:Status <= 199
               ::cError := "TMsXml:SendHttpRequest: INFORMATIVA (" + cValToChar( ::oHttp:Status ) + "#"+ ::oHttp:statusText + ")"
            CASE ::oHttp:Status >= 200 .AND. ::oHttp:Status <= 299
               ::cError := "TMsXml:SendHttpRequest: SATISFACTORIA (" + cValToChar( ::oHttp:Status ) + "#"+ ::oHttp:statusText + ")"
            CASE ::oHttp:Status >= 300 .AND. ::oHttp:Status <= 399
               ::cError := "TMsXml:SendHttpRequest: REDIRECCION (" + cValToChar( ::oHttp:Status ) + "#"+ ::oHttp:statusText + ")"
            CASE ::oHttp:Status >= 400 .AND. ::oHttp:Status <= 499
               ::nError := MSXML_ERROR_RESULT_ERROR_CLIENTE //(peticiones incorrectas del lado del cliente)
               ::cError := "TMsXml:SendHttpRequest: ERROR en el CLIENTE (" + cValToChar( ::oHttp:Status ) + "#"+ ::oHttp:statusText + ")"
            CASE ::oHttp:Status >= 500 .AND. ::oHttp:Status <= 599

               ::nError := MSXML_ERROR_RESULT_ERROR_SERVIDOR //(errores que tienen lugar del lado del servidor)

               ::cError := "TMsXml:SendHttpRequest: SERVER ERROR (" + cValToChar( ::oHttp:Status )

               DO CASE
               CASE ::oHttp:Status = 500
                  ::cError += "#"+ "Internal Server Error: El servidor encontro un error interno o una configuracin incorrecta y no pudo completar su solicitud" + ")"
               CASE ::oHttp:Status = 501
                  ::cError += "#"+ "Not implemented: El servidor no reconoce el mtodo de peticin, o carece de la capacidad para cumplir la peticin" + ")"
               CASE ::oHttp:Status = 502
                  ::cError += "#"+ "Bad Gateway: El servidor encontr un error temporal y no pudo completar su solicitud" + ")"
               CASE ::oHttp:Status = 503
                  ::cError += "#"+ "Service not available: El servidor no puede atender su solicitud temporalmente por mantenimiento o a problemas de capacidad." + ")"
               CASE ::oHttp:Status = 504
                  ::cError += "#"+ "Gateway Time-out NGINX: La solicitud se cancelo porque el servidor tardo demasiado en responder" + ")"
               OTHERWISE
                  ::cError += "#"+ ::oHttp:statusText + ")"
               ENDCASE

            END CASE

         CATCH

	    TRY
               DO CASE
               CASE ::oHttp:Status = 200 .OR.;   //en pruebas cuando se desconecto el WiFi
                    ::oHttp:Status = 12029 .OR.; //12029 ERROR_INTERNET_CANNOT_CONNECT    The attempt to connect to the server failed.
                    ::oHttp:Status = 12007	 //12007 ERROR_INTERNET_NAME_NOT_RESOLVED The server name could not be resolved.

                  ::nError := MSXML_ERROR_HTTP_SEND_SIN_CONEXION
                  ::cError := "TMsXml:SendHttpRequest: SIN CONEXION A INTERNET"
               OTHERWISE
                  ::nError := MSXML_ERROR_HTTP_SEND_NO_RESPONSE
                  ::cError := "TMsXml:SendHttpRequest: ERROR DESCONOCIDO (" + cValToChar( ::oHttp:Status ) + "#"+ ::oHttp:statusText + ")"
               END CASE
	    CATCH
               ::nError := MSXML_ERROR_HTTP_SEND_NO_RESPONSE
               ::cError := "TMsXml:SendHttpRequest: ERROR DESCONOCIDO (TimeOut,..)"

	    END

         END

      endif
   return cResponse

   //------------------------------------------------//
   METHOD SetXSD_Schema( cFileXSD ) CLASS TMsXml
      if ::oSchema = NIL
         TRY
            ::oSchema := CreateObject("MSXML2.DOMDocument.6.0")
            ::oSchema:async := .F.
            ::oSchema:load( cFileXSD )
         CATCH
            ::nError := MSXML_ERROR_FAIL_ON_CREATE_XSD_SCHEMA
            ::cError := "TMsXml:SetXSD_Schema: No se pudo crear 'MSXML2.DOMDocument.6.0'"
         END
      else
         ::oSchema:load( cFileXSD )
      endif
   RETURN ::oSchema <> NIL
   //------------------------------------------------//
   METHOD SetXSD_SchemaCache( ) CLASS TMsXml
      if ::oSchemaCache = NIL
         TRY
            ::oSchemaCache := CreateObject("MSXML2.XMLSchemaCache.6.0")
            ::oSchemaCache:add( "", ::oSchema )
         CATCH
            ::nError := MSXML_ERROR_FAIL_ON_CREATE_XSD_SCHEMA_CACHE
            ::cError := "TMsXml:SetXSD_SchemaCache: No se pudo crear 'MSXML2.XMLSchemaCache.6.0'"
         END
      else
         ::oSchemaCache:add( "", ::oSchema )
      endif
   RETURN ::oSchemaCache <> NIL
   //------------------------------------------------//
   METHOD SetDoc( cFileXML ) CLASS TMsXml
      if ::oXmlDoc = NIL
         TRY
            ::oXmlDoc := CreateObject("MSXML2.DOMDocument.6.0")
            ::oXmlDoc:async := .F.
            ::oXmlDoc:validateOnParse := .F.
            ::oXmlDoc:resolveExternals = .F.
            ::oXmlDoc:schemas := ::oSchemaCache
            ::oXmlDoc:load( cFileXML )
         CATCH
            ::nError := MSXML_ERROR_FAIL_ON_CREATE_XML_DOCUMENT
            ::cError := "TMsXml:SetDoc: No se pudo crear 'MSXML2.DOMDocument.6.0'"
         END
      else
         ::oXmlDoc:schemas := ::oSchemaCache
         ::oXmlDoc:load( cFileXML )
      endif
   RETURN ::oXmlDoc <> NIL
   //------------------------------------------------//
   METHOD ValidateXSD( cFileXML, cFileXSD ) CLASS TMsXml
      Local lOk := .F.

      Do Case
      Case Empty(cFileXML) .OR. !File(cFileXML)
         ::nError := MSXML_ERROR_VALIDATE_XSD_FILE_XML
         ::cError := "TMsXml:ValidateXSD: No existe el archivo XML a validar"
      Case Empty(cFileXSD) .OR. !File(cFileXSD)
         ::nError := MSXML_ERROR_VALIDATE_XSD_FILE_XSD
         ::cError := "TMsXml:ValidateXSD: No existe el archivo XSD validador"
      OtherWise
         if ::SetXSD( cFileXSD )
            if ::SetDoc( cFileXML )

               ::oParseError := ::oXmlDoc:validate()
               if empty( ::oParseError:errorCode )
                  lOk := .t.
               else
                  ::nError := MSXML_ERROR_VALIDATE_XSD
                  ::cError := "TMsXml:ValidateXSD: " + cStr( ::oParseError:errorCode ) + "#"+ cStr( ::oParseError:reason )
               endif

            endif
         endif
      endcase
   RETURN lOk

